## telepathy-ofono 0.2daily13.06.14.1

=== CMakeLists.txt ===
project(telepathy-ofono)
cmake_minimum_required(VERSION 2.8)

# Standard install paths
include(GNUInstallDirs)

# Check for include files
include(CheckIncludeFileCXX)

find_package(Qt5Core)
find_package(Qt5DBus)
add_definitions(-DQT_NO_KEYWORDS)

find_package(PkgConfig REQUIRED)
pkg_check_modules(TP_QT5 REQUIRED TelepathyQt5)

if(NOT DAEMON_DIR)
  set(DAEMON_DIR lib/telepathy)
endif(NOT DAEMON_DIR)

set(CMAKE_AUTOMOC ON)

include_directories(${TP_QT5_INCLUDE_DIRS})
include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(/usr/include/telepathy-qt5/)
include_directories(/usr/include/ofono-qt/)

find_library(TELEPATHY_QT5_LIBRARIES telepathy-qt5)
find_library(TELEPATHY_QT5_SERVICE_LIBRARIES telepathy-qt5-service)
find_library(OFONO_QT_LIBRARIES ofono-qt)

add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp)
qt5_use_modules(telepathy-ofono Core DBus)

target_link_libraries(telepathy-ofono ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES})
install(TARGETS telepathy-ofono DESTINATION ${DAEMON_DIR})

configure_file(ofono.service.in org.freedesktop.Telepathy.ConnectionManager.ofono.service)
install (FILES ofono.manager DESTINATION share/telepathy/managers)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Telepathy.ConnectionManager.ofono.service DESTINATION share/dbus-1/services)

## telepathy-ofono 0.2+13.10.20130809

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,12 @@
 find_package(Qt5Core)
 find_package(Qt5DBus)
 add_definitions(-DQT_NO_KEYWORDS)
+
+check_include_file_cxx("waudio.h" USE_AUDIOFLINGER)
+if (USE_AUDIOFLINGER)
+    add_definitions(-DUSE_AUDIOFLINGER)
+    set(WAUDIO_LIBRARIES -lwaudio)
+endif (USE_AUDIOFLINGER)
 
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(TP_QT5 REQUIRED TelepathyQt5)
@@ -33,7 +39,7 @@
 add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp)
 qt5_use_modules(telepathy-ofono Core DBus)
 
-target_link_libraries(telepathy-ofono ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES})
+target_link_libraries(telepathy-ofono ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES})
 install(TARGETS telepathy-ofono DESTINATION ${DAEMON_DIR})
 
 configure_file(ofono.service.in org.freedesktop.Telepathy.ConnectionManager.ofono.service)

## telepathy-ofono 0.2+13.10.20130821

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,7 +36,7 @@
 find_library(TELEPATHY_QT5_SERVICE_LIBRARIES telepathy-qt5-service)
 find_library(OFONO_QT_LIBRARIES ofono-qt)
 
-add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp)
+add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp)
 qt5_use_modules(telepathy-ofono Core DBus)
 
 target_link_libraries(telepathy-ofono ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES})

## telepathy-ofono 0.2+13.10.20131008.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,12 @@
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(TP_QT5 REQUIRED TelepathyQt5)
 
+pkg_check_modules(PULSEAUDIO libpulse)
+if (PULSEAUDIO_FOUND)
+    add_definitions(-DUSE_PULSEAUDIO)
+    include_directories(${PULSEAUDIO_INCLUDE_DIRS})
+endif (PULSEAUDIO_FOUND)
+
 if(NOT DAEMON_DIR)
   set(DAEMON_DIR lib/telepathy)
 endif(NOT DAEMON_DIR)
@@ -36,10 +42,10 @@
 find_library(TELEPATHY_QT5_SERVICE_LIBRARIES telepathy-qt5-service)
 find_library(OFONO_QT_LIBRARIES ofono-qt)
 
-add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp)
+add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp qpulseaudioengine.cpp)
 qt5_use_modules(telepathy-ofono Core DBus)
 
-target_link_libraries(telepathy-ofono ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES})
+target_link_libraries(telepathy-ofono ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES})
 install(TARGETS telepathy-ofono DESTINATION ${DAEMON_DIR})
 
 configure_file(ofono.service.in org.freedesktop.Telepathy.ConnectionManager.ofono.service)

## telepathy-ofono 0.2+14.04.20131205.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
 pkg_check_modules(PULSEAUDIO libpulse)
 if (PULSEAUDIO_FOUND)
     add_definitions(-DUSE_PULSEAUDIO)
+    set(USE_PULSEAUDIO ON)
     include_directories(${PULSEAUDIO_INCLUDE_DIRS})
 endif (PULSEAUDIO_FOUND)
 
@@ -42,8 +43,14 @@
 find_library(TELEPATHY_QT5_SERVICE_LIBRARIES telepathy-qt5-service)
 find_library(OFONO_QT_LIBRARIES ofono-qt)
 
-add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp qpulseaudioengine.cpp)
+if(USE_PULSEAUDIO)
+    add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp qpulseaudioengine.cpp phoneutils.cpp)
+else(USE_PULSEAUDIO)
+    add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp phoneutils.cpp)
+endif(USE_PULSEAUDIO)
 qt5_use_modules(telepathy-ofono Core DBus)
+
+enable_testing()
 
 target_link_libraries(telepathy-ofono ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES})
 install(TARGETS telepathy-ofono DESTINATION ${DAEMON_DIR})
@@ -51,3 +58,5 @@
 configure_file(ofono.service.in org.freedesktop.Telepathy.ConnectionManager.ofono.service)
 install (FILES ofono.manager DESTINATION share/telepathy/managers)
 install (FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Telepathy.ConnectionManager.ofono.service DESTINATION share/dbus-1/services)
+
+add_subdirectory(tests)

=== tests/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
    )

macro(generate_tests)
    foreach(test ${ARGN})
        add_executable(${test} ${test}.cpp ${CMAKE_SOURCE_DIR}/phoneutils.cpp)
        qt5_use_modules(${test} Core DBus Test)
        add_test(${test} ${CMAKE_CURRENT_BINARY_DIR}/${test} -xunitxml -o ${CMAKE_BINARY_DIR}/test_${test}.xml)
    endforeach(test)
endmacro(generate_tests)

generate_tests(
    PhoneUtilsTest
    )

## telepathy-ofono 0.2+14.04.20131211

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,33 @@
 project(telepathy-ofono)
 cmake_minimum_required(VERSION 2.8)
+set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
+set(TELEPATHY_OFONO telepathy-ofono)
+
+# Find includes in corresponding build directories
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
 # Standard install paths
 include(GNUInstallDirs)
 
 # Check for include files
 include(CheckIncludeFileCXX)
+
+include(EnableCoverageReport)
+#####################################################################
+# Enable code coverage calculation with gcov/gcovr/lcov
+# Usage:
+#  * Switch build type to coverage (use ccmake or cmake-gui)
+#  * Invoke make, make test, make coverage
+#  * Find html report in subdir coveragereport
+#  * Find xml report feasible for jenkins in coverage.xml
+#####################################################################
+IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
+  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
+  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -coverage" )
+  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -coverage" )
+  ENABLE_COVERAGE_REPORT(TARGETS ${TELEPATHY_OFONO})
+ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
 
 find_package(Qt5Core)
 find_package(Qt5DBus)
@@ -27,6 +49,8 @@
     include_directories(${PULSEAUDIO_INCLUDE_DIRS})
 endif (PULSEAUDIO_FOUND)
 
+find_program(DBUS_RUNNER dbus-test-runner)
+
 if(NOT DAEMON_DIR)
   set(DAEMON_DIR lib/telepathy)
 endif(NOT DAEMON_DIR)
@@ -44,16 +68,16 @@
 find_library(OFONO_QT_LIBRARIES ofono-qt)
 
 if(USE_PULSEAUDIO)
-    add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp qpulseaudioengine.cpp phoneutils.cpp)
+    add_executable(${TELEPATHY_OFONO} main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp qpulseaudioengine.cpp phoneutils.cpp)
 else(USE_PULSEAUDIO)
-    add_executable(telepathy-ofono main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp phoneutils.cpp)
+    add_executable(${TELEPATHY_OFONO} main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp phoneutils.cpp)
 endif(USE_PULSEAUDIO)
-qt5_use_modules(telepathy-ofono Core DBus)
+qt5_use_modules(${TELEPATHY_OFONO} Core DBus)
 
 enable_testing()
 
-target_link_libraries(telepathy-ofono ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES})
-install(TARGETS telepathy-ofono DESTINATION ${DAEMON_DIR})
+target_link_libraries(${TELEPATHY_OFONO} ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES})
+install(TARGETS ${TELEPATHY_OFONO} DESTINATION ${DAEMON_DIR})
 
 configure_file(ofono.service.in org.freedesktop.Telepathy.ConnectionManager.ofono.service)
 install (FILES ofono.manager DESTINATION share/telepathy/managers)

=== tests/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
    )

macro(generate_test TESTNAME USE_DBUS)
    add_executable(${TESTNAME} ${ARGN} ${TESTNAME}.cpp)
    qt5_use_modules(${TESTNAME} Core DBus Test)
    set(TEST_COMMAND )
    if (${USE_DBUS})
        set(TEST_COMMAND -p ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME} -p -xunitxml -p -o -p ${CMAKE_BINARY_DIR}/test_${TESTNAME}.xml)
        add_test(${TESTNAME} ${DBUS_RUNNER} --keep-env --task /usr/bin/pulseaudio --ignore-return --task ${CMAKE_CURRENT_BINARY_DIR}/dbus-test-wrapper.sh ${TEST_COMMAND})
    else (${USE_DBUS})
        add_test(${TESTNAME} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME} -xunitxml -o ${CMAKE_BINARY_DIR}/test_${TESTNAME}.xml)
    endif(${USE_DBUS})
    # force telepathy not to use system approvers when available,
    # also force usage of memory backend in history-service
    set(TMPDIR "/tmp/tpofono_test_home")
    set(TEST_ENVIRONMENT "HOME=${TMPDIR};
                          HISTORY_SQLITE_DBPATH=:memory:;
                          XDG_CONFIG_HOME=${TMPDIR};
                          XDG_DATA_HOME=${TMPDIR};
                          XDG_CACHE_DIR=${TMPDIR};
                          XDG_CACHE_HOME=${TMPDIR};
                          XDG_DATA_DIRS=${TMPDIR};
                          MC_ACCOUNT_DIR=${TMPDIR};
                          MC_MANAGER_DIR=${TMPDIR}")
    set_tests_properties(${TESTNAME} PROPERTIES
                          ENVIRONMENT "${TEST_ENVIRONMENT}"
                          TIMEOUT 30)
    target_link_libraries(${TESTNAME}
                          ${TP_QT5_LIBRARIES}
                         )
endmacro(generate_test)

configure_file(dbus-test-wrapper.sh.in ${CMAKE_CURRENT_BINARY_DIR}/dbus-test-wrapper.sh)

generate_test(PhoneUtilsTest False ${CMAKE_SOURCE_DIR}/phoneutils.cpp)

if (DBUS_RUNNER)
    generate_test(ConnectionTest True telepathyhelper.cpp ofonomockcontroller.cpp)
    generate_test(MessagesTest True telepathyhelper.cpp ofonomockcontroller.cpp handler.cpp approvertext.cpp)
    generate_test(CallTest True telepathyhelper.cpp ofonomockcontroller.cpp handler.cpp approvercall.cpp)
endif(DBUS_RUNNER)

add_subdirectory(mock)

## telepathy-ofono 0.2+14.04.20140407

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,7 @@
 
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(TP_QT5 REQUIRED TelepathyQt5)
+pkg_check_modules(SQLITE3 REQUIRED sqlite3)
 
 pkg_check_modules(PULSEAUDIO libpulse)
 if (PULSEAUDIO_FOUND)
@@ -60,6 +61,7 @@
 include_directories(${TP_QT5_INCLUDE_DIRS})
 include_directories(${Qt5Core_INCLUDE_DIRS})
 include_directories(${Qt5DBus_INCLUDE_DIRS})
+include_directories(${SQLITE3_INCLUDE_DIRS})
 include_directories(/usr/include/telepathy-qt5/)
 include_directories(/usr/include/ofono-qt/)
 
@@ -67,20 +69,53 @@
 find_library(TELEPATHY_QT5_SERVICE_LIBRARIES telepathy-qt5-service)
 find_library(OFONO_QT_LIBRARIES ofono-qt)
 
+qt5_add_resources(telepathyfono_RES sqlitetelepathyofono.qrc)
+
+# update the .qrc file automatically when there are new schema files
+file(GLOB QRC_RESOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.sql ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.info)
+set(QRC_FILE ${CMAKE_CURRENT_SOURCE_DIR}/sqlitetelepathyofono.qrc)
+add_custom_command(
+    OUTPUT ${QRC_FILE}
+    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/update_qrc.sh ${QRC_FILE}
+    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+    DEPENDS ${QRC_RESOURCE_FILES}
+    )
+add_custom_target(qrc_update DEPENDS ${QRC_FILE} schema_update)
+
+set(TELEPATHY_OFONO_SRC 
+   main.cpp
+   protocol.cpp
+   connection.cpp
+   ofonotextchannel.cpp
+   ofonocallchannel.cpp
+   ofonoconferencecallchannel.cpp
+   voicemailiface.cpp
+   speakeriface.cpp
+   mmsdmanager.cpp
+   mmsdservice.cpp
+   mmsdmessage.cpp
+   pendingmessagesmanager.cpp
+   phoneutils.cpp
+   sqlitedatabase.cpp
+   ussdiface.cpp
+   ${telepathyfono_RES})
+
 if(USE_PULSEAUDIO)
-    add_executable(${TELEPATHY_OFONO} main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp qpulseaudioengine.cpp phoneutils.cpp)
+    add_executable(${TELEPATHY_OFONO} qpulseaudioengine.cpp ${TELEPATHY_OFONO_SRC})
 else(USE_PULSEAUDIO)
-    add_executable(${TELEPATHY_OFONO} main.cpp protocol.cpp connection.cpp ofonotextchannel.cpp ofonocallchannel.cpp voicemailiface.cpp speakeriface.cpp mmsdmanager.cpp mmsdservice.cpp mmsdmessage.cpp phoneutils.cpp)
+    add_executable(${TELEPATHY_OFONO} ${TELEPATHY_OFONO_SRC})
 endif(USE_PULSEAUDIO)
-qt5_use_modules(${TELEPATHY_OFONO} Core DBus)
+qt5_use_modules(${TELEPATHY_OFONO} Core DBus Sql)
+add_dependencies(${TELEPATHY_OFONO} schema_update qrc_update)
 
 enable_testing()
 
-target_link_libraries(${TELEPATHY_OFONO} ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES})
+target_link_libraries(${TELEPATHY_OFONO} ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES} ${SQLITE3_LIBRARIES})
 install(TARGETS ${TELEPATHY_OFONO} DESTINATION ${DAEMON_DIR})
 
 configure_file(ofono.service.in org.freedesktop.Telepathy.ConnectionManager.ofono.service)
 install (FILES ofono.manager DESTINATION share/telepathy/managers)
 install (FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Telepathy.ConnectionManager.ofono.service DESTINATION share/dbus-1/services)
 
+add_subdirectory(schema)
 add_subdirectory(tests)

=== tests/mock/CMakeLists.txt ===
set(library_SRCS
    callvolumeprivate.cpp
    messagemanagerprivate.cpp
    messageprivate.cpp
    modemprivate.cpp
    voicecallmanagerprivate.cpp
    voicecallprivate.cpp
    networkregistrationprivate.cpp
    ofonocallvolume.cpp
    ofonointerface.cpp
    ofonomessage.cpp
    ofonomessagemanager.cpp
    ofonomessagewaiting.cpp
    ofonomodem.cpp
    ofonomodeminterface.cpp
    ofonomodemmanager.cpp
    ofononetworkregistration.cpp
    ofonovoicecall.cpp
    ofonovoicecallmanager.cpp
    )

include_directories(
    ${CMAKE_BINARY_DIR}
)

qt5_add_dbus_adaptor(library_SRCS CallVolumePrivate.xml callvolumeprivate.h CallVolumePrivate)
qt5_add_dbus_adaptor(library_SRCS ModemPrivate.xml modemprivate.h ModemPrivate)
qt5_add_dbus_adaptor(library_SRCS NetworkRegistrationPrivate.xml networkregistrationprivate.h NetworkRegistrationPrivate)
qt5_add_dbus_adaptor(library_SRCS MessageManagerPrivate.xml messagemanagerprivate.h MessageManagerPrivate)
qt5_add_dbus_adaptor(library_SRCS MessagePrivate.xml messageprivate.h MessagePrivate)
qt5_add_dbus_adaptor(library_SRCS VoiceCallManagerPrivate.xml voicecallmanagerprivate.h VoiceCallManagerPrivate)
qt5_add_dbus_adaptor(library_SRCS VoiceCallPrivate.xml voicecallprivate.h VoiceCallPrivate)

add_library(ofono-qt SHARED ${library_SRCS})

# Set the library version and the SOVERSION
#set_target_properties(historyservice PROPERTIES
#                      SOVERSION ${HISTORY_VERSION_MAJOR}
#                      VERSION ${HISTORY_VERSION_MAJOR}.${HISTORY_VERSION_MINOR}.${HISTORY_VERSION_PATCH})

qt5_use_modules(ofono-qt Core DBus)

## telepathy-ofono 0.2+15.04.20141216

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
     set(TEST_COMMAND )
     if (${USE_DBUS})
         set(TEST_COMMAND -p ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME} -p -xunitxml -p -o -p ${CMAKE_BINARY_DIR}/test_${TESTNAME}.xml)
-        add_test(${TESTNAME} ${DBUS_RUNNER} --keep-env --task /usr/bin/pulseaudio --ignore-return --task ${CMAKE_CURRENT_BINARY_DIR}/dbus-test-wrapper.sh ${TEST_COMMAND})
+        add_test(${TESTNAME} ${DBUS_RUNNER} --keep-env --task ${CMAKE_CURRENT_BINARY_DIR}/dbus-test-wrapper.sh ${TEST_COMMAND})
     else (${USE_DBUS})
         add_test(${TESTNAME} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME} -xunitxml -o ${CMAKE_BINARY_DIR}/test_${TESTNAME}.xml)
     endif(${USE_DBUS})
@@ -18,13 +18,15 @@
     set(TMPDIR "/tmp/tpofono_test_home")
     set(TEST_ENVIRONMENT "HOME=${TMPDIR};
                           HISTORY_SQLITE_DBPATH=:memory:;
+                          TP_OFONO_SQLITE_DBPATH=:memory:;
                           XDG_CONFIG_HOME=${TMPDIR};
                           XDG_DATA_HOME=${TMPDIR};
                           XDG_CACHE_DIR=${TMPDIR};
                           XDG_CACHE_HOME=${TMPDIR};
                           XDG_DATA_DIRS=${TMPDIR};
                           MC_ACCOUNT_DIR=${TMPDIR};
-                          MC_MANAGER_DIR=${TMPDIR}")
+                          MC_MANAGER_DIR=${TMPDIR};
+                          PA_DISABLED=1")
     set_tests_properties(${TESTNAME} PROPERTIES
                           ENVIRONMENT "${TEST_ENVIRONMENT}"
                           TIMEOUT 30)

## telepathy-ofono 0.2+15.04.20150331

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 cmake_minimum_required(VERSION 2.8)
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
 set(TELEPATHY_OFONO telepathy-ofono)
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 
 # Find includes in corresponding build directories
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -32,12 +33,6 @@
 find_package(Qt5Core)
 find_package(Qt5DBus)
 add_definitions(-DQT_NO_KEYWORDS)
-
-check_include_file_cxx("waudio.h" USE_AUDIOFLINGER)
-if (USE_AUDIOFLINGER)
-    add_definitions(-DUSE_AUDIOFLINGER)
-    set(WAUDIO_LIBRARIES -lwaudio)
-endif (USE_AUDIOFLINGER)
 
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(TP_QT5 REQUIRED TelepathyQt5)
@@ -89,13 +84,16 @@
    ofonotextchannel.cpp
    ofonocallchannel.cpp
    ofonoconferencecallchannel.cpp
+   emergencymodeiface.cpp
    voicemailiface.cpp
-   speakeriface.cpp
+   audiooutputsiface.cpp
    mmsdmanager.cpp
    mmsdservice.cpp
    mmsdmessage.cpp
    pendingmessagesmanager.cpp
    phoneutils.cpp
+   powerdaudiomodemediator.cpp
+   powerddbus.cpp
    sqlitedatabase.cpp
    ussdiface.cpp
    ${telepathyfono_RES})

## telepathy-ofono 0.2+15.10.20150721

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,6 +37,7 @@
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(TP_QT5 REQUIRED TelepathyQt5)
 pkg_check_modules(SQLITE3 REQUIRED sqlite3)
+pkg_check_modules(MC_PLUGINS REQUIRED mission-control-plugins)
 
 pkg_check_modules(PULSEAUDIO libpulse)
 if (PULSEAUDIO_FOUND)
@@ -117,3 +118,4 @@
 
 add_subdirectory(schema)
 add_subdirectory(tests)
+add_subdirectory(mc-plugin)

## telepathy-ofono 0.2+15.10.20150810

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -26,12 +26,14 @@
                           XDG_DATA_DIRS=${TMPDIR};
                           MC_ACCOUNT_DIR=${TMPDIR};
                           MC_MANAGER_DIR=${TMPDIR};
+                          MC_CLIENTS_DIR=${TMPDIR};
                           PA_DISABLED=1")
     set_tests_properties(${TESTNAME} PROPERTIES
                           ENVIRONMENT "${TEST_ENVIRONMENT}"
                           TIMEOUT 30)
     target_link_libraries(${TESTNAME}
                           ${TP_QT5_LIBRARIES}
+                          ${LibPhoneNumber_LIBRARIES}
                          )
 endmacro(generate_test)

## telepathy-ofono 0.2+16.04.20151120

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,7 @@
   ENABLE_COVERAGE_REPORT(TARGETS ${TELEPATHY_OFONO})
 ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
 
+find_package(LibPhoneNumber REQUIRED)
 find_package(Qt5Core)
 find_package(Qt5DBus)
 add_definitions(-DQT_NO_KEYWORDS)
@@ -58,6 +59,7 @@
 include_directories(${Qt5Core_INCLUDE_DIRS})
 include_directories(${Qt5DBus_INCLUDE_DIRS})
 include_directories(${SQLITE3_INCLUDE_DIRS})
+include_directories(${LibPhoneNumber_INCLUDE_DIRS})
 include_directories(/usr/include/telepathy-qt5/)
 include_directories(/usr/include/ofono-qt/)
 
@@ -65,7 +67,7 @@
 find_library(TELEPATHY_QT5_SERVICE_LIBRARIES telepathy-qt5-service)
 find_library(OFONO_QT_LIBRARIES ofono-qt)
 
-qt5_add_resources(telepathyfono_RES sqlitetelepathyofono.qrc)
+qt5_add_resources(telepathyfono_RES sqlitetelepathyofono.qrc countrycodes.qrc)
 
 # update the .qrc file automatically when there are new schema files
 file(GLOB QRC_RESOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.sql ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.info)
@@ -109,7 +111,7 @@
 
 enable_testing()
 
-target_link_libraries(${TELEPATHY_OFONO} ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES} ${SQLITE3_LIBRARIES})
+target_link_libraries(${TELEPATHY_OFONO} ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES} ${SQLITE3_LIBRARIES} ${LibPhoneNumber_LIBRARIES})
 install(TARGETS ${TELEPATHY_OFONO} DESTINATION ${DAEMON_DIR})
 
 configure_file(ofono.service.in org.freedesktop.Telepathy.ConnectionManager.ofono.service)

=== mc-plugin/CMakeLists.txt ===
set(MCP_ACCOUNT_MANAGER_NAME mcp-account-manager-ofono)

set(MC_PLUGIN_SRC
    mcp-account-manager-ofono.c
    mission-control-plugin.c
)

set(MC_PLUGIN_HDRS
    mcp-account-manager-ofono.h
)

execute_process(COMMAND pkg-config --variable=plugindir mission-control-plugins
     OUTPUT_VARIABLE MC_PLUGINS_DIR)
string(REPLACE "\n" "" MC_PLUGINS_DIR ${MC_PLUGINS_DIR})

include_directories(${MC_PLUGINS_INCLUDE_DIRS})
add_library(${MCP_ACCOUNT_MANAGER_NAME} SHARED ${MC_PLUGIN_SRC} ${MC_PLUGIN_HDRS})
set_target_properties(${MCP_ACCOUNT_MANAGER_NAME} PROPERTIES PREFIX "")
target_link_libraries(${MCP_ACCOUNT_MANAGER_NAME} ${MC_PLUGINS_LIBRARIES})

install(TARGETS ${MCP_ACCOUNT_MANAGER_NAME} DESTINATION ${MC_PLUGINS_DIR})

=== schema/CMakeLists.txt ===
file(GLOB SCHEMA_FILES ${CMAKE_CURRENT_SOURCE_DIR}/v*.sql)

set(SCHEMA_FILE ${CMAKE_CURRENT_SOURCE_DIR}/schema.sql)
set(VERSION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/version.info)

add_custom_command(
    OUTPUT ${SCHEMA_FILE} ${VERSION_FILE}
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/update_schema.sh ${CMAKE_CURRENT_SOURCE_DIR} ${SCHEMA_FILE} ${VERSION_FILE}
    WORKING DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${SCHEMA_FILES}
    )

add_custom_target(schema_update DEPENDS ${SCHEMA_FILE} ${VERSION_FILE})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,7 @@
 
 if (DBUS_RUNNER)
     generate_test(ConnectionTest True telepathyhelper.cpp ofonomockcontroller.cpp)
+    generate_test(ProtocolTest True telepathyhelper.cpp)
     generate_test(MessagesTest True telepathyhelper.cpp ofonomockcontroller.cpp handler.cpp approvertext.cpp)
     generate_test(CallTest True telepathyhelper.cpp ofonomockcontroller.cpp handler.cpp approvercall.cpp)
 endif(DBUS_RUNNER)

=== tests/mock/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
     modemprivate.cpp
     voicecallmanagerprivate.cpp
     voicecallprivate.cpp
+    simmanagerprivate.cpp
     networkregistrationprivate.cpp
     ofonocallvolume.cpp
     ofonointerface.cpp
@@ -17,6 +18,7 @@
     ofononetworkregistration.cpp
     ofonovoicecall.cpp
     ofonovoicecallmanager.cpp
+    ofonosimmanager.cpp
     )
 
 include_directories(
@@ -30,6 +32,7 @@
 qt5_add_dbus_adaptor(library_SRCS MessagePrivate.xml messageprivate.h MessagePrivate)
 qt5_add_dbus_adaptor(library_SRCS VoiceCallManagerPrivate.xml voicecallmanagerprivate.h VoiceCallManagerPrivate)
 qt5_add_dbus_adaptor(library_SRCS VoiceCallPrivate.xml voicecallprivate.h VoiceCallPrivate)
+qt5_add_dbus_adaptor(library_SRCS SimManagerPrivate.xml simmanagerprivate.h SimManagerPrivate)
 
 add_library(ofono-qt SHARED ${library_SRCS})

## telepathy-ofono 0.2+17.04.20161109

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,6 +33,7 @@
 find_package(LibPhoneNumber REQUIRED)
 find_package(Qt5Core)
 find_package(Qt5DBus)
+find_package(Qt5Network)
 add_definitions(-DQT_NO_KEYWORDS)
 
 find_package(PkgConfig REQUIRED)
@@ -93,6 +94,7 @@
    mmsdmanager.cpp
    mmsdservice.cpp
    mmsdmessage.cpp
+   mmsgroupcache.cpp
    pendingmessagesmanager.cpp
    phoneutils.cpp
    powerdaudiomodemediator.cpp
@@ -111,7 +113,7 @@
 
 enable_testing()
 
-target_link_libraries(${TELEPATHY_OFONO} ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES} ${SQLITE3_LIBRARIES} ${LibPhoneNumber_LIBRARIES})
+target_link_libraries(${TELEPATHY_OFONO} ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES}  ${Qt5Network_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES} ${SQLITE3_LIBRARIES} ${LibPhoneNumber_LIBRARIES})
 install(TARGETS ${TELEPATHY_OFONO} DESTINATION ${DAEMON_DIR})
 
 configure_file(ofono.service.in org.freedesktop.Telepathy.ConnectionManager.ofono.service)

## telepathy-ofono 0.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,10 @@
-project(telepathy-ofono)
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.5)
+project(telepathy-ofono VERSION 0.3.1 LANGUAGES CXX C)
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
 set(TELEPATHY_OFONO telepathy-ofono)
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 
 # Find includes in corresponding build directories
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -31,42 +33,27 @@
 ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
 
 find_package(LibPhoneNumber REQUIRED)
-find_package(Qt5Core)
-find_package(Qt5DBus)
-find_package(Qt5Network)
+find_package(Qt5 REQUIRED COMPONENTS Core DBus Network)
 add_definitions(-DQT_NO_KEYWORDS)
 
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(TP_QT5 REQUIRED TelepathyQt5)
 pkg_check_modules(SQLITE3 REQUIRED sqlite3)
 pkg_check_modules(MC_PLUGINS REQUIRED mission-control-plugins)
-
-pkg_check_modules(PULSEAUDIO libpulse)
-if (PULSEAUDIO_FOUND)
-    add_definitions(-DUSE_PULSEAUDIO)
-    set(USE_PULSEAUDIO ON)
-    include_directories(${PULSEAUDIO_INCLUDE_DIRS})
-endif (PULSEAUDIO_FOUND)
+pkg_check_modules(OFONO_QT REQUIRED ofono-qt)
 
 find_program(DBUS_RUNNER dbus-test-runner)
-
-if(NOT DAEMON_DIR)
-  set(DAEMON_DIR lib/telepathy)
-endif(NOT DAEMON_DIR)
 
 set(CMAKE_AUTOMOC ON)
 
 include_directories(${TP_QT5_INCLUDE_DIRS})
-include_directories(${Qt5Core_INCLUDE_DIRS})
-include_directories(${Qt5DBus_INCLUDE_DIRS})
 include_directories(${SQLITE3_INCLUDE_DIRS})
 include_directories(${LibPhoneNumber_INCLUDE_DIRS})
 include_directories(/usr/include/telepathy-qt5/)
-include_directories(/usr/include/ofono-qt/)
+include_directories(${OFONO_QT_INCLUDE_DIRS})
 
 find_library(TELEPATHY_QT5_LIBRARIES telepathy-qt5)
 find_library(TELEPATHY_QT5_SERVICE_LIBRARIES telepathy-qt5-service)
-find_library(OFONO_QT_LIBRARIES ofono-qt)
 
 qt5_add_resources(telepathyfono_RES sqlitetelepathyofono.qrc countrycodes.qrc)
 
@@ -82,6 +69,7 @@
 add_custom_target(qrc_update DEPENDS ${QRC_FILE} schema_update)
 
 set(TELEPATHY_OFONO_SRC 
+   cellbroadcastreceiver.cpp
    main.cpp
    protocol.cpp
    connection.cpp
@@ -90,31 +78,24 @@
    ofonoconferencecallchannel.cpp
    emergencymodeiface.cpp
    voicemailiface.cpp
-   audiooutputsiface.cpp
    mmsdmanager.cpp
    mmsdservice.cpp
    mmsdmessage.cpp
    mmsgroupcache.cpp
    pendingmessagesmanager.cpp
    phoneutils.cpp
-   powerdaudiomodemediator.cpp
-   powerddbus.cpp
    sqlitedatabase.cpp
    ussdiface.cpp
    ${telepathyfono_RES})
 
-if(USE_PULSEAUDIO)
-    add_executable(${TELEPATHY_OFONO} qpulseaudioengine.cpp ${TELEPATHY_OFONO_SRC})
-else(USE_PULSEAUDIO)
-    add_executable(${TELEPATHY_OFONO} ${TELEPATHY_OFONO_SRC})
-endif(USE_PULSEAUDIO)
+add_executable(${TELEPATHY_OFONO} ${TELEPATHY_OFONO_SRC})
 qt5_use_modules(${TELEPATHY_OFONO} Core DBus Sql)
 add_dependencies(${TELEPATHY_OFONO} schema_update qrc_update)
 
 enable_testing()
 
-target_link_libraries(${TELEPATHY_OFONO} ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES} ${WAUDIO_LIBRARIES} -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES}  ${Qt5Network_LIBRARIES} ${OFONO_QT_LIBRARIES} ${PULSEAUDIO_LIBRARIES} ${SQLITE3_LIBRARIES} ${LibPhoneNumber_LIBRARIES})
-install(TARGETS ${TELEPATHY_OFONO} DESTINATION ${DAEMON_DIR})
+target_link_libraries(${TELEPATHY_OFONO} Qt5::Core Qt5::DBus -ltelepathy-qt5 ${TELEPATHY_QT5_SERVICE_LIBRARIES}  Qt5::Network ${OFONO_QT_LIBRARIES} ${SQLITE3_LIBRARIES} ${LibPhoneNumber_LIBRARIES})
+install(TARGETS ${TELEPATHY_OFONO} DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})
 
 configure_file(ofono.service.in org.freedesktop.Telepathy.ConnectionManager.ofono.service)
 install (FILES ofono.manager DESTINATION share/telepathy/managers)

=== mc-plugin/CMakeLists.txt ===
execute_process(COMMAND pkg-config --variable=plugindir mission-control-plugins
     OUTPUT_VARIABLE MC_PLUGINS_DIR)
string(REPLACE "\n" "" MC_PLUGINS_DIR ${MC_PLUGINS_DIR})

include_directories(${MC_PLUGINS_INCLUDE_DIRS})

set(MCP_ACCOUNT_MANAGER_OFONO_NAME mcp-account-manager-ofono)

set(MC_OFONO_PLUGIN_SRC
    mission-control-plugin.c
    mcp-account-manager-ofono.c
)

set(MC_OFONO_PLUGIN_HDRS
    mcp-account-manager-ofono.h
)

add_library(${MCP_ACCOUNT_MANAGER_OFONO_NAME} SHARED ${MC_OFONO_PLUGIN_SRC}
    ${MC_OFONO_PLUGIN_HDRS})
set_target_properties(${MCP_ACCOUNT_MANAGER_OFONO_NAME} PROPERTIES PREFIX "")
target_link_libraries(${MCP_ACCOUNT_MANAGER_OFONO_NAME} ${MC_PLUGINS_LIBRARIES})
install(TARGETS ${MCP_ACCOUNT_MANAGER_OFONO_NAME} DESTINATION ${MC_PLUGINS_DIR})

set(MCP_ACCOUNT_MANAGER_OFONO_RING_NAME mcp-account-manager-ofono-on-ring)

set(MC_OFONO_RING_PLUGIN_SRC
    mission-control-plugin.c
    mcp-account-manager-ofono-on-ring.c
)

add_library(${MCP_ACCOUNT_MANAGER_OFONO_RING_NAME} SHARED
    ${MC_OFONO_RING_PLUGIN_SRC} ${MC_OFONO_PLUGIN_HDRS})
set_target_properties(${MCP_ACCOUNT_MANAGER_OFONO_RING_NAME} PROPERTIES
    PREFIX "")
target_link_libraries(${MCP_ACCOUNT_MANAGER_OFONO_RING_NAME}
    ${MC_PLUGINS_LIBRARIES})
install(TARGETS ${MCP_ACCOUNT_MANAGER_OFONO_RING_NAME} DESTINATION
    ${MC_PLUGINS_DIR})

=== schema/CMakeLists.txt ===
--- 
+++ 
@@ -11,3 +11,6 @@
     )
 
 add_custom_target(schema_update DEPENDS ${SCHEMA_FILE} ${VERSION_FILE})
+
+# just to get the v*sql files to show on QtCreator
+add_custom_target(schema_files_target ALL SOURCES ${SCHEMA_FILES})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -3,9 +3,10 @@
     ${CMAKE_SOURCE_DIR}
     )
 
+find_package(Qt5 REQUIRED COMPONENTS Test)
+
 macro(generate_test TESTNAME USE_DBUS)
     add_executable(${TESTNAME} ${ARGN} ${TESTNAME}.cpp)
-    qt5_use_modules(${TESTNAME} Core DBus Test)
     set(TEST_COMMAND )
     if (${USE_DBUS})
         set(TEST_COMMAND -p ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME} -p -xunitxml -p -o -p ${CMAKE_BINARY_DIR}/test_${TESTNAME}.xml)
@@ -34,6 +35,7 @@
     target_link_libraries(${TESTNAME}
                           ${TP_QT5_LIBRARIES}
                           ${LibPhoneNumber_LIBRARIES}
+                          Qt5::Core Qt5::DBus Qt5::Test
                          )
 endmacro(generate_test)
 
@@ -46,6 +48,7 @@
     generate_test(ProtocolTest True telepathyhelper.cpp)
     generate_test(MessagesTest True telepathyhelper.cpp ofonomockcontroller.cpp handler.cpp approvertext.cpp)
     generate_test(CallTest True telepathyhelper.cpp ofonomockcontroller.cpp handler.cpp approvercall.cpp)
+    generate_test(CellBroadcastTest True telepathyhelper.cpp ofonomockcontroller.cpp handler.cpp approvertext.cpp)
 endif(DBUS_RUNNER)
 
 add_subdirectory(mock)

=== tests/mock/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 set(library_SRCS
     callvolumeprivate.cpp
+    cellbroadcastprivate.cpp
     messagemanagerprivate.cpp
     messageprivate.cpp
     modemprivate.cpp
@@ -8,6 +9,7 @@
     simmanagerprivate.cpp
     networkregistrationprivate.cpp
     ofonocallvolume.cpp
+    ofonocellbroadcast.cpp
     ofonointerface.cpp
     ofonomessage.cpp
     ofonomessagemanager.cpp
@@ -33,12 +35,17 @@
 qt5_add_dbus_adaptor(library_SRCS VoiceCallManagerPrivate.xml voicecallmanagerprivate.h VoiceCallManagerPrivate)
 qt5_add_dbus_adaptor(library_SRCS VoiceCallPrivate.xml voicecallprivate.h VoiceCallPrivate)
 qt5_add_dbus_adaptor(library_SRCS SimManagerPrivate.xml simmanagerprivate.h SimManagerPrivate)
+qt5_add_dbus_adaptor(library_SRCS CellBroadcastPrivate.xml cellbroadcastprivate.h CellBroadcastPrivate)
 
-add_library(ofono-qt SHARED ${library_SRCS})
+
+add_library(ofono-qt-mock SHARED ${library_SRCS})
+set_target_properties(ofono-qt-mock PROPERTIES
+     OUTPUT_NAME "ofono-qt"
+)
 
 # Set the library version and the SOVERSION
 #set_target_properties(historyservice PROPERTIES
 #                      SOVERSION ${HISTORY_VERSION_MAJOR}
 #                      VERSION ${HISTORY_VERSION_MAJOR}.${HISTORY_VERSION_MINOR}.${HISTORY_VERSION_PATCH})
 
-qt5_use_modules(ofono-qt Core DBus)
+qt5_use_modules(ofono-qt-mock Core DBus)

=== debian/changelog ===
telepathy-ofono (0.3.1-5) unstable; urgency=medium

  * debian/copyright:
    + Update FSF mailing address.
    + Update copyright attributions for debian/.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/{rules,telepathy-ofono.install}:
    + Explicitly install files install to /usr/* and the apparmor profile we
      ship as part of the packaging.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 18 Aug 2025 21:04:27 +0200

telepathy-ofono (0.3.1-4) unstable; urgency=medium

  * debian/patches:
    + Add 1002_mc-plugin-mcp-account-manager-ofono-on-ring.c-Type-c.patch.
      Type cast g_object_ref to McpAccountManager*. Fixes FTBFS against GCC-14.
      (Closes: #1075561).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 05 Oct 2024 19:12:49 +0200

telepathy-ofono (0.3.1-3) unstable; urgency=medium

  * debian/:
    + Drop bin:pkgs telepathy-ofono-on-ring-ril-mc-plugin and telepathy-ofono-
      ril-mc-plugin for now. They required libhybris and are only relevant for
      Android-based devices.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 26 May 2024 17:03:11 +0200

telepathy-ofono (0.3.1-2) unstable; urgency=medium

  * Re-upload source-only as is.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 12 May 2024 23:21:26 +0200

telepathy-ofono (0.3.1-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1070233).

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 02 May 2024 23:12:47 +0200

=== debian/control ===
Source: telepathy-ofono
Section: comm
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               dbus-test-runner,
               dconf-cli,
               dh-apparmor,
               gnome-keyring,
               libmission-control-plugins-dev (>= 1:5.14.0),
               libofono-qt-dev (>= 1.30),
               libphonenumber-dev,
               libqt5sql5-sqlite,
               libtelepathy-qt5-dev (>= 0.9.3),
               libsqlite3-dev,
               qtbase5-dev (>= 5.0),
               sqlite3,
               telepathy-mission-control-5
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/core/packaging/telepathy-ofono
Vcs-Git: https://salsa.debian.org/ubports-team/telepathy-ofono.git
Vcs-Browser: https://salsa.debian.org/ubports-team/telepathy-ofono/

Package: telepathy-ofono
Architecture: any
Depends: ofono,
         ${misc:Depends},
         ${shlibs:Depends},
Description: telepathy oFono connection manager
 telepathy-ofono is a Telepathy connection manager that makes it possible for
 Telepathy clients to communicate using oFono modems, enabling features like
 real phone calls and send and receive SMSs.

#Package: telepathy-ofono-ril-mc-plugin
#Conflicts: telepathy-ofono-on-ring-ril-mc-plugin
#Architecture: amd64 i386 armhf arm64
#Depends: telepathy-ofono,
#         ${misc:Depends},
#         ${shlibs:Depends},
#         libhybris-utils
#Description: telepathy oFono mission control plugin for ril modems
# telepathy-ofono is a Telepathy connection manager that makes it possible for
# Telepathy clients to communicate using oFono modems, enabling features like
# real phone calls and send and receive SMSs.
# .
# This telepathy mission-control plugin is used to automatically provision
# telepathy-ofono accounts for each available ril modem.

#Package: telepathy-ofono-on-ring-ril-mc-plugin
#Conflicts: telepathy-ofono-ril-mc-plugin
#Architecture: amd64 i386 armhf arm64
#Depends: telepathy-ofono,
#         ${misc:Depends},
#         ${shlibs:Depends},
#Description: telepathy oFono on-ring mission control plugin for ril modems
# telepathy-ofono is a Telepathy connection manager that makes it possible for
# Telepathy clients to communicate using oFono modems, enabling features like
# real phone calls and send and receive SMSs.
# .
# This telepathy mission-control plugin is used to automatically provision
# telepathy-ofono accounts for each available ril modem on ring.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DPKG_GENSYMBOLS_CHECK_LEVEL=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/architecture.mk

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=libexec/telepathy

override_dh_auto_test:
#	CTEST_OUTPUT_ON_FAILURE=1 make -C obj-$(DEB_HOST_GNU_TYPE) test

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

# Unfortunately dh_apparmor doesn't come with a debhelper addon (i.e. the
# ability to specify `dh --with=apparmor`). Its manpage suggests adding it to
# override_dh_install. However, we can do better.
execute_after_dh_auto_install:
	dh_apparmor --profile-name=usr.lib.telepathy.telepathy-ofono -ptelepathy-ofono

%:
	dh $@

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
